﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Editors;
using Infragistics.Windows.DataPresenter;

namespace DisableNumFields
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = new List<Data>
            {
                new Data { Name = "Name 1", Value = 100, ShouldUseCoverter = true },
                new Data { Name = "Name 2", Value = 300, ShouldUseCoverter = false },
                new Data { Name = "Name 3", Value = 200, ShouldUseCoverter = true },
            };

        }
    }

    public class EditorStyleSelector : StyleSelector
    {
        public override Style SelectStyle(object item, DependencyObject container)
        {
            CellValuePresenter cell = container as CellValuePresenter;

            Data data = cell.Record.DataItem as Data;

            if (data != null && data.ShouldUseCoverter)
            {
                Style nonEditStyle = new Style(typeof(XamNumericEditor));
                nonEditStyle.Setters.Add(new Setter(XamNumericEditor.ValueToDisplayTextConverterProperty, new NotEditableFieldValueConverter()));

                return nonEditStyle;
            }

            return new Style(typeof(XamNumericEditor));
        }
    }

    public class NotEditableFieldValueConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value.ToString() +  " - ";
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class Data
    {
        public string Name { get; set; }
        public int Value { get; set; }
        public bool ShouldUseCoverter { get; set; }
    }

}
